/*
 * Created on 6-lug-2004
 */
package sid;

import java.io.Serializable;

/**
 * Thread coordination monitor
 * @author Francesco Suzzi
 */
public class Monitor implements Serializable{	
	private boolean locked;	
	/**
	 * Default monitor constructor, monitor is initially unlocked
	 */
	public Monitor(){
		this.locked=false;
	}	
	/**
	 * Free monitor access
	 */
	public synchronized void unlock(){
		this.locked=false;
		this.notifyAll();
		//System.out.println("sbloccato");
	}
	/**
	 * Check monitor availability, if it's free he lock it
	 */
	public synchronized void checkLock(){
		while(this.locked){
			//System.out.println("bloccato");
			try{this.wait();}
			catch(InterruptedException e){System.out.println(e);}
		}
		this.locked=true;
	}
	/**
	 * Tells if monitor is locked
	 * @return True if it's locked, false otherwise
	 */
	public boolean isLocked() {
		return locked;
	}
}
